/****************************************************************************
**
** Copyright (C) 1992-2009 Nokia. All rights reserved.
**
** This file is part of Qt Jambi.
**
** ** No Commercial Usage
** This file contains pre-release code and may not be distributed.
** You may use this file in accordance with the terms and conditions
** contained in the either Technology Preview License Agreement or the
** Beta Release License Agreement.
**
** If you are unsure which license is appropriate for your use, please
** contact the sales department at qt-sales@nokia.com.


**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#include "customtypes.h"

#include "metajava.h"

#include <QtCore/QDebug>
#include <QtCore/QTextStream>


void QModelIndexTypeEntry::generateCppJavaToQt(QTextStream &s,
                                               const AbstractMetaType *,
                                               const QString &env_name,
                                               const QString &qt_name,
                                               const QString &java_name) const
{
    s << "QModelIndex " << qt_name << " = qtjambi_to_QModelIndex(" << env_name << ", "
      << java_name << ")";
}


void QModelIndexTypeEntry::generateCppQtToJava(QTextStream &s,
                                               const AbstractMetaType *,
                                               const QString &env_name,
                                               const QString &qt_name,
                                               const QString &java_name) const
{
    s << "jobject " << java_name << " = qtjambi_from_QModelIndex(" << env_name << ", "
      << qt_name << ")";
}
